/** Fichier station.c **/

/******************************************************************/
/**                        Serveur IMAP2                         **/
/******************************************************************/

/** Fichiers d'inclusion **/
#include <stdio.h>
#include <getopt.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/dir.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <poll.h>
#include <time.h>
#include "station.h"
#include "libcom.h"
#include "libthrd.h"

/*************************************Verif LOGIN*******************************************/

int VerifLogin(char *arg1, char *arg2)
{
	int login_ok;
	FILE *monFichier = NULL;
	monFichier = fopen("LOGIN.txt", "r");
	char login[MAX_LIGNE] = "";
	char buffer_arg1[MAX_LIGNE] = "";
	strcpy(buffer_arg1, arg1);
	if (monFichier != NULL)
	{
		strcat(buffer_arg1, "\n");
		while (fgets(login, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
		{
			if (strcmp(buffer_arg1, login) == 0)
			{
				login_ok = 1;
			}
		}

		fclose(monFichier);
		return login_ok;
	}
	else
	{
		// On affiche un message d'erreur si on veut
		printf("Impossible d'ouvrir le fichier test.txt");
	}

	fclose(monFichier);

	return 0;
}
/*************************************Nombres de mail***************************************/

int Nombre_mail(char *user, char *arg1)
{
	struct dirent **namelist;
	int n, n_max;
	int iFile_txt = 0;
	char Chemin[MAX_LIGNE] = "";
	if ((strcmp(arg1, "INBOX") == 0) | (strcmp(arg1, "") == 0))
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX", user);
	}
	else
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/%s", user, arg1);
	}

	n = scandir(Chemin, &namelist, 0, alphasort);
	n_max = n;
	if (n < 0)
	{
		perror("scandir");
		return -1;
	}
	else
	{
		for (n = 0; n < n_max; n++)
		{
			if (strstr(namelist[n]->d_name, ".txt") != NULL)
			{ // On cherche si le fichier contient .txt
				iFile_txt++;
			}
			free(namelist[n]);
		}
		free(namelist);
	}
	return iFile_txt;
}

/************************************LECTURE FLAGS******************************************/

nombre_flags_t Lect_Flags(char *user, nombre_flags_t nb_flags, int nb_mail, int *tab_sup, int *tab_sup2, char *arg1)
{
	struct dirent **namelist;
	nb_flags.Recent = 0;
	nb_flags.Deleted = 0;
	char Chemin[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";
	int j = 0;
	int k = 0;
	int n, n_max, val1;
	char cVal[6];
	char Memo_mail_status[100][MAX_LIGNE];

	if ((strcmp(arg1, "INBOX") == 0) | (strcmp(arg1, "") == 0))
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX", user);
	}
	else
	{
		sprintf(Chemin, "../Messages/Utilisateur/%s/%s", user, arg1);
	}

	n = scandir(Chemin, &namelist, 0, alphasort);
	n_max = n;
	if (n < 0)
	{
		perror("scandir");
	}
	else
	{
		for (n = 2; n < n_max; n++)
		{
			if (strstr(namelist[n]->d_name, ".status") != NULL)
			{
				strcpy(Memo_mail_status[j], namelist[n]->d_name);
				j++;
				//printf("******1: %s \n",namelist[n]->d_name);
			}
			free(namelist[n]);
		}
		free(namelist);
		j = 0;
	}

	for (int i = 0; i < nb_mail + 1; i++) // on parcours tout les mails
	{
		FILE *monFichier = NULL;
		sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%s", user, Memo_mail_status[i]);

		monFichier = fopen(Chemin, "r");
		if (monFichier != NULL)
		{
			while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				if (strcmp(Flag_R, msg_recu) == 0)
				{
					nb_flags.Recent = nb_flags.Recent + 1;
					tab_sup[j] = i;
					j = j + 1;
				}
				if (strcmp(Flag_D, msg_recu) == 0)
				{
					nb_flags.Deleted = nb_flags.Deleted + 1;
					sprintf(cVal, "%c%c%c", Memo_mail_status[i][0], Memo_mail_status[i][1], Memo_mail_status[i][2]); //on recupere le numero de mail
					val1 = atoi(cVal);																				 //conversion en int
					tab_sup2[k] = val1;																				 //on le rajoute dans un tableau pour pouvoir faire un expunge
					k = k + 1;
				}
			}

			fclose(monFichier);
		}
		else
		{
			// On affiche un message d'erreur si on veut
			printf("Impossible d'ouvrir les mails de %s \n", user);
		}
	}
	memset(Memo_mail_status, 0, sizeof(Memo_mail_status));

	return nb_flags;
}
/************************************Supprimer Ligne******************************************/

int Sup_Ligne(char *user, char *Flag, int num_mail) //num status = numero du .status a supprimer le Flag
{
	char Chemin[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";
	char buff_tempo[MAX_LIGNE] = "";

	FILE *monFichier = NULL;

	sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, num_mail);

	printf("CHEMIN sup ligne : %s\n", Chemin);

	monFichier = fopen(Chemin, "r");

	if ((monFichier != NULL))
	{
		while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
		{
			if (strcmp(Flag, msg_recu) != 0)
			{
				strcat(buff_tempo, msg_recu);
			}
		}
		printf("buff_tempo : \n%s\n", buff_tempo);
		fclose(monFichier);
	}
	else
	{
		printf("Erreur ouverture fichier sup\n");
		return 0;
	}

	monFichier = fopen(Chemin, "w+");
	if ((monFichier != NULL))
	{
		fputs(buff_tempo, monFichier);
		fclose(monFichier);
		return 1;
	}
	else
	{
		printf("Erreur fermeture fichier sup\n");
		return 0;
	}
}

/************************************Ajouter ligne******************************************/
void Ajt_Ligne(char *user, char *Flag, char *num_mail)
{
	char Chemin[MAX_LIGNE] = "";
	FILE *monFichier = NULL;
	sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%s.status", user, num_mail);
	printf("CHEMIN ajout ligne : %s\n", Chemin);

	monFichier = fopen(Chemin, "a+");

	if (monFichier != NULL)
	{
		fputs(Flag, monFichier);
		printf("ok ligne ajouté: %s\n", Flag);
		fclose(monFichier);
	}
	else
	{
		printf("Erreur ouverture fichier AJOUTER\n");
	}
}
/************************************Fonction ENUM ******************************************/

int Enum_nb(char *tag,char *arg1, int *tab_enum, char *user,FILE *dialogue)
{
	int nb_enum;
	int j = 0;
	int val1 = 0;
	int val2 = 0;
	char cVal1[2],cVal2[6],cVal3[2];
	char Chemin[MAX_LIGNE] = "";
	char reponse_client[MAX_LIGNE] = "";
	sprintf(cVal1, "%c", arg1[0]);
	sprintf(cVal3, "%c", arg1[1]);
	sprintf(cVal2, "%c%c%c", arg1[2], arg1[3], arg1[4]);

	val1 = atoi(cVal1);
	val2 = atoi(cVal2);
	nb_enum = val2; //nombre max de valeur
	struct stat st = {0};

	if ((val1 < val2) && (strcmp(cVal3, ":") == 0))
	{
		for (int i = val1; i < val2 + 1; i++)
		{
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, i);
			printf("\n*****%d\nchemin :%s", i, Chemin);
			if (stat(Chemin, &st) == -1)
			{
				printf("\n Fichier %d.txt/status n'existe pas \n", i);
				sprintf(reponse_client, "%s NO mail %d does not exist", tag, i);
				fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
			}
			else
			{
				printf("\n*****COPIED %d\n", i);
				tab_enum[j] = i;
				printf("i : %d \n", i);
				j = j + 1;
			}
		}
		return nb_enum;
	}
	else
	{
		printf("erreur syntaxe");
	}
	return 0;
}
/************************************Fonction COPY ******************************************/

void fct_copy(char *user, char *arg2, int *tab_enum, int nb_enum)
{
	char Chemin[MAX_LIGNE] = "";
	char Chemin_status[MAX_LIGNE] = "";
	char Chemin2_status[MAX_LIGNE] = "";
	char Chemin_txt[MAX_LIGNE] = "";
	char Chemin2_txt[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";
	char buffer[MAX_LIGNE] = "";

	FILE *monFichier_status = NULL;
	FILE *monFichier2_status = NULL;

	FILE *monFichier_txt = NULL;
	FILE *monFichier2_txt = NULL;
	sprintf(Chemin, "../Messages/Utilisateur/%s/%s/", user, arg2);

	struct stat st = {0};

	if (stat(Chemin2_status, &st) == -1)
	{
		mkdir(Chemin, 0777);
		printf("******* Chemin Répertoire crée************\n\n");
	}

	for (int i = 0; i < nb_enum; i++)
	{
		sprintf(buffer, "%d", tab_enum[i]);
		//printf("tabenum %d \n",tab_enum[i]);
		if (strcmp(buffer, "0") == 0)
		{
			printf("le fichier a copier n'existe pas : %d \na ", tab_enum[i]);
		}
		else
		{
			sprintf(Chemin_status, "../Messages/Utilisateur/%s/INBOX/%d.status", user, tab_enum[i]);
			sprintf(Chemin2_status, "../Messages/Utilisateur/%s/%s/%d.status", user, arg2, tab_enum[i]);

			sprintf(Chemin_txt, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			sprintf(Chemin2_txt, "../Messages/Utilisateur/%s/%s/%d.txt", user, arg2, tab_enum[i]);

			monFichier_status = fopen(Chemin_status, "r");
			monFichier2_status = fopen(Chemin2_status, "w+");

			monFichier_txt = fopen(Chemin_txt, "r+");
			monFichier2_txt = fopen(Chemin2_txt, "w+");

			//printf("*****%s\n",Chemin2_txt);

			if (monFichier_status != NULL)
			{
				while (fgets(msg_recu, MAX_LIGNE, monFichier_status) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
				{
					fputs(msg_recu, monFichier2_status);
					//printf("tout ok");
				}

				fclose(monFichier_status);
				fclose(monFichier2_status);
			}
			else
			{
				printf("FILE STATUS NOT CREATED/OPENED \n");
			}

			if (monFichier_txt != NULL)
			{
				while (fgets(msg_recu, MAX_LIGNE, monFichier_txt) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
				{
					fputs(msg_recu, monFichier2_txt);
				}

				fclose(monFichier_txt);
				fclose(monFichier2_txt);
			}

			else
			{
				printf("FILE TXT NOT CREATED/OPENED");
			}
		}
	}
	//return 0;
}

/*************************************GESTION CLIENT ***************************************/

int gestionClientTCP(int s)
{
	nombre_flags_t nb_flags;
	fetch_t fetch_att;
	char ligne[MAX_LIGNE];
	char tag[MAX_LIGNE], fct[MAX_LIGNE], arg1[MAX_LIGNE], arg2[MAX_LIGNE], arg3[MAX_LIGNE];
	char user[MAX_LIGNE] = "";
	char reponse_client[MAX_LIGNE] = "";

	int login_ok = 0;
	int tab_sup[MAX_LIGNE] = {0};
	int tab_sup2[MAX_LIGNE] = {0};
	int tab_enum[MAX_LIGNE] = {0};
	//int s=*(int *)arg;

	/* Obtient une structure de fichier */
	FILE *dialogue = fdopen(s, "a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if (dialogue == NULL)
	{
		perror("gestionClientTCP.fdopen");
		exit(EXIT_FAILURE);
	}

	fwrite(reponse_log0, 1, sizeof(reponse_log0), dialogue);

	while (fgets(ligne, MAX_LIGNE, dialogue) != NULL) //while(fgets(ligne,MAX_LIGNE,dialogue)) //while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL && strlen(ligne) < 3)
	{
		sscanf(ligne, "%s %s %s %s %s", tag, fct, arg1, arg2, arg3);
		//printf(">tag: %s >fct: %s >arg1: %s >arg2: %s >arg3 : %s \n", tag, fct, arg1, arg2, arg3);

		if (strcmp(fct, "LOGIN") == 0)
		{
			login_ok = Login(tag, arg1, arg2, dialogue);
			strcpy(user, arg1);
		}

		else if ((strcmp(fct, "LOGOUT") == 0) && login_ok == 1)
		{
			login_ok = Logout(tag, dialogue);
		}

		else if ((strcmp(fct, "NOOP") == 0) && login_ok == 1)
		{
			Noop(tag, dialogue);
		}

		else if ((strcmp(fct, "SELECT") == 0) && login_ok == 1)
		{
			Select(tag, user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		else if ((strcmp(fct, "CHECK") == 0) && login_ok == 1)
		{
			Check(tag, user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		else if ((strcmp(fct, "EXPUNGE") == 0) && login_ok == 1)
		{

			Expunge(tag, user, nb_flags, tab_sup, tab_sup2, dialogue, arg1);
		}

		else if ((strcmp(fct, "STORE") == 0) && login_ok == 1)
		{
			Store(tag, user, arg1, arg2, arg3, dialogue);
		}

		else if ((strcmp(fct, "COPY") == 0) && login_ok == 1)
		{
			Copy(tag, arg1, arg2, user, tab_enum, dialogue);
		}
		else if ((strcmp(fct, "FETCH") == 0) && login_ok == 1)
		{
			Fetch(tag, arg1, arg2, user, tab_enum, fetch_att, dialogue);
		}

		else if (!(strcmp(fct, "") == 0) && !(strcmp(fct, "LOGIN") == 0) && login_ok == 0)
		{
			printf("***************%s***********",tag);
			sprintf(reponse_client, "%s %s", tag, reponse_log10);
			fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
		}

		else 
		{
			sprintf(reponse_client, "%s %s", tag, reponse_log3);
			fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
		}

		strcpy(arg1, "");
		strcpy(arg2, "");
		strcpy(arg3, "");
	}

	/* Termine la connexion */
	fclose(dialogue);
	printf("client %d déconnecté\n", s);
	return 0;
}

int multi_gestionClientTCP(int s)
{
	//int dialogue= s;

	lanceThread(gestionClientTCP, (int)s, 0);
	return 0;
}

void serveur_TCP(void)
{
	int s = 0;

	/* Initialisation du serveur */
	s = initialisationServeurTCP(port, MAX_connexions);
	/* Lancement de la boucle d'ecoute */
	//boucleServeurTCP(s,gestionClientTCP);
	boucleServeurTCP(s, multi_gestionClientTCP);

	/* On termine la connexion */
	shutdown(s, SHUT_RDWR);
}

int main(int argc, char *argv[])
{

	//analyse de l'argument
	chemin_spool = analyseArguments(argc, argv);

	serveur_TCP();
	return 0;
}

/*********************************************************************************FONCTIONS*****************************************************************************************/

int Login(char tag[MAX_LIGNE], char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], FILE *dialogue)
{

	int login_ok;
	char reponse_client[MAX_LIGNE] = "";

	login_ok = VerifLogin(arg1, arg2);

	if ((login_ok == 1) && (strcmp(arg2, "") != 0))
	{

		sprintf(reponse_client, "%s OK User %s logged in\n", tag, arg1);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
		return 1;
	}
	else if ((login_ok == 0))
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log9);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue); // utilisateur inexistant
		return 0;
	}
	else
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log2);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue); //mauvais mdp
		return 0;
	}
}

int Logout(char tag[MAX_LIGNE], FILE *dialogue)
{
	char reponse_client[MAX_LIGNE] = "";
	sprintf(reponse_client, "%s %s", tag, reponse_log4);
	fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);

	return 0;
}

void Noop(char tag[MAX_LIGNE], FILE *dialogue)
{
	char reponse_client[MAX_LIGNE] = "";
	sprintf(reponse_client, "%s %s", tag, reponse_log5);
	fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
}

void Select(char tag[MAX_LIGNE], char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{
	char reponse_client[MAX_LIGNE] = "";
	int nb_mail = Nombre_mail(user, arg1);
	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";

	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_client, "%s %s", tag, reponse_log11);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
	else
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log8);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
}

void Check(char tag[MAX_LIGNE], char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{
	char reponse_client[MAX_LIGNE] = "";
	int nb_mail = Nombre_mail(user, arg1);
	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";

	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_client, "%s %s", tag, reponse_log12);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
	else
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log8);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
}

void Expunge(char tag[MAX_LIGNE], char user[MAX_LIGNE], nombre_flags_t nb_flags, int *tab_sup, int *tab_sup2, FILE *dialogue, char arg1[MAX_LIGNE])
{

	int nb_mail = Nombre_mail(user, arg1);
	nb_flags = Lect_Flags(user, nb_flags, nb_mail, tab_sup, tab_sup2, arg1);
	char reponse_log[MAX_LIGNE] = "";
	char Chemin[MAX_LIGNE] = "";
	char reponse_client[MAX_LIGNE] = "";
	if (nb_mail != -1)
	{
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_log, "* %d RECENT\n", nb_flags.Recent);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);

		for (int i = 0; i < nb_flags.Deleted; i++)
		{
			printf("fichier contient : %d\n", tab_sup2[i]);
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, tab_sup2[i]);
			remove(Chemin);
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_sup2[i]);
			remove(Chemin);
		}
		nb_mail = Nombre_mail(user, arg1);
		sprintf(reponse_log, "* %d EXISTS\n", nb_mail);
		fwrite(reponse_log, 1, sizeof(reponse_log), dialogue);
		sprintf(reponse_client, "%s %s", tag, reponse_log13);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
	else
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log8);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);	}
}

void Store(char tag[MAX_LIGNE], char user[MAX_LIGNE], char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], char arg3[MAX_LIGNE], FILE *dialogue)
{

	char Flag[MAX_LIGNE] = "";
	char reponse_client[MAX_LIGNE] = "";
	char charToConvert[2]; //pour convertir un char en int
	int charConverted;	 //pour convertir un char en int

	if (strcmp(arg3, "\\Deleted") == 0)
	{
		strcpy(Flag, Flag_D);
	} // FLAG = DELETED
	else if (strcmp(arg3, "\\Seen") == 0)
	{
		strcpy(Flag, Flag_S);
	} // FLAG = SEEN
	else if (strcmp(arg3, "\\Recent") == 0)
	{
		strcpy(Flag, Flag_R);
	} // FLAG = RECENT
	else if (strcmp(arg3, "\\Answered") == 0)
	{
		strcpy(Flag, Flag_A);
	} // FLAG = ANSWERED
	else if (strcmp(arg3, "\\Flagged") == 0)
	{
		strcpy(Flag, Flag_F);
	} // FLAG = FLAGGED
	else
	{
		printf("error store arg 3\n");
		sprintf(reponse_client, "%s %s", tag, reponse_log14);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}

	if (strcmp(arg2, "+Flags") == 0)
	{
		Ajt_Ligne(user, Flag, arg1);
		sprintf(reponse_client, "%s %s", tag, reponse_log15);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
	else if (strcmp(arg2, "-Flags") == 0)
	{
		sprintf(charToConvert, "%s", arg1);
		charConverted = atoi(charToConvert); //permet de convertir un char en int pour le passé en parametre a la fct sup_ligne
		Sup_Ligne(user, Flag, charConverted);
		sprintf(reponse_client, "%s %s", tag, reponse_log15);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
	else
	{
		sprintf(reponse_client, "%s %s", tag, reponse_log14);
		fwrite(reponse_client, 1, sizeof(reponse_client), dialogue);
	}
}

void Copy(char tag[MAX_LIGNE], char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], char user[MAX_LIGNE], int *tab_enum, FILE *dialogue)
{
	int nb_enum = Enum_nb(tag,arg1, tab_enum, user,dialogue);
	fct_copy(user, arg2, tab_enum, nb_enum);
	memset(tab_enum, 0, sizeof(tab_enum));
}

void Fetch(char tag[MAX_LIGNE], char arg1[MAX_LIGNE], char arg2[MAX_LIGNE], char user[MAX_LIGNE], int *tab_enum, fetch_t fetch_att, FILE *dialogue)
{
	int nb_enum = Enum_nb(tag,arg1, tab_enum, user,dialogue);

	if ((strcmp(arg2, "FLAGS") == 0) | (strcmp(arg2, "ALL") == 0) | (strcmp(arg2, "FAST") == 0))
	{
		fetch_att.iFlags = 1;
	}
	if ((strcmp(arg2, "INTERNALDATE") == 0) | (strcmp(arg2, "ALL") == 0) | (strcmp(arg2, "FAST") == 0))
	{
		fetch_att.iInternaldate = 1;
	}
	if ((strcmp(arg2, "RFC822.SIZE") == 0) | (strcmp(arg2, "ALL") == 0) | (strcmp(arg2, "FAST") == 0))
	{
		fetch_att.iRfc_size = 1;
	}
	if ((strcmp(arg2, "ENVELOPE") == 0) | (strcmp(arg2, "ALL") == 0))
	{
		fetch_att.iEnvelope = 1;
	}
	if ((strcmp(arg2, "RFC822.TEXT") == 0) | (strcmp(arg2, "RFC822") == 0))
	{
		fetch_att.iRfc_text = 1;
	}
	if ((strcmp(arg2, "RFC822.HEADER") == 0) | (strcmp(arg2, "RFC822") == 0))
	{
		fetch_att.iRfc_header = 1;
	}
	printf("FLAGS : %d, INTERNALDATE : %d, RFC822.SIZE : %d, ENVELOPE : %d,RFC822.HEADER :%d RFC822.TEXT : %d ", fetch_att.iFlags, fetch_att.iInternaldate, fetch_att.iRfc_size, fetch_att.iEnvelope, fetch_att.iRfc_header, fetch_att.iRfc_text);
	Lect_Mail(fetch_att, dialogue, user, tab_enum, nb_enum);

	memset(tab_enum, 0, sizeof(tab_enum));
}

/*************************************************************LECTURE MAILS***************************************************/

void Lect_Mail(fetch_t fecth_att, FILE *dialogue, char *user, int *tab_enum, int nb_enum)
{
	char Chemin[MAX_LIGNE] = "";
	char buffer[MAX_LIGNE] = "";
	char buffer2[MAX_LIGNE] = "";
	char rfc822_size[MAX_LIGNE] = "";
	char Reponse_final[MAX_LIGNE] = "";
	char msg_recu[MAX_LIGNE] = "";
	char contenu_Header[MAX_LIGNE] = "";
	char contenu_Text[MAX_LIGNE] = "";
	char flag_recu[MAX_LIGNE][MAX_LIGNE] = {""};
	char contenu_Envelope[MAX_LIGNE] = "Envelope";
	char internaldate[MAX_LIGNE] = "";
	int iNb_size[MAX_TAMPON];
	int len_char;
	int iBuffer;

	for (int i = 0; i < nb_enum; i++)
	{
		/*******************************Lect_Mail:FLAGS***********************/
		if (fecth_att.iFlags == 1)
		{
			FILE *monFichier = NULL;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.status", user, tab_enum[i]);
			monFichier = fopen(Chemin, "r");
			if (monFichier != NULL)
			{
				printf("ok");
				strcat(flag_recu[i], "((FLAGS ");
				while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas (NULL)
				{
					if (strcmp(Flag_S, msg_recu) == 0)
					{
						strcat(flag_recu[i], "(\\Seen) ");
					}
					if (strcmp(Flag_R, msg_recu) == 0)
					{
						strcat(flag_recu[i], "(\\Recent) ");
					}
					if (strcmp(Flag_D, msg_recu) == 0)
					{
						strcat(flag_recu[i], "(\\Deleted) ");
					}
					if (strcmp(Flag_A, msg_recu) == 0)
					{
						strcat(flag_recu[i], "(\\Answered) ");
					}
					if (strcmp(Flag_F, msg_recu) == 0)
					{
						strcat(flag_recu[i], "(\\Flagged) ");
					}
				}
				strcat(flag_recu[i], ")");
				printf("**%d** : %s \n", i, flag_recu[i]);
				//fwrite(flag_recu[i], 1, sizeof(flag_recu[i]), dialogue);

				fclose(monFichier);
			}
			else
			{
				printf("FICHIER N'EXISTE PAS \n");
				printf("FLAGS ELSE %s \n", flag_recu[i]);
			}
		}

		/*******************************Lect_Mail:Internaldate***********************/
		if (fecth_att.iInternaldate == 1)
		{
			struct stat buf;
			char *timebuf;
			int result;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			result = stat(Chemin, &buf);
			if (result != 0)
			{
				strcpy(buffer, "");
			}
			else
			{

				timebuf = ctime(&buf.st_mtime);
				printf("File %d date : %s \n", tab_enum[i], timebuf);

				len_char = strlen(timebuf);
				timebuf[(len_char - 1)] = '\0';

				sprintf(buffer, "InternalDate \" %s \" ", timebuf);
			}

			strcat(internaldate, buffer);
			//fwrite(internaldate, 1, sizeof(internaldate), dialogue);
		}
		/*******************************Lect_Mail:822.size***********************/
		if (fecth_att.iRfc_size == 1)
		{
			FILE *monFichier = NULL;
			int caractereActuel = 0;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			monFichier = fopen(Chemin, "r");

			if (monFichier != NULL)
			{
				// Boucle de lecture des caractères un à un
				do
				{
					caractereActuel = fgetc(monFichier);
					iNb_size[i] = iNb_size[i] + 1;

				} while (caractereActuel != EOF);

				fclose(monFichier);
			}
			sprintf(rfc822_size, "RFC822.Size %d \n ", iNb_size[i]);
			//fwrite(rfc822_size, 1, sizeof(rfc822_size), dialogue);
		}

		/*******************************Lect_Mail:ENVELOPE*************************/
		if (fecth_att.iEnvelope == 1)
		{
			FILE *monFichier = NULL;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			monFichier = fopen(Chemin, "r");
			if (monFichier != NULL)
			{
				while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On cherche si le fichier contient les élement qui definisse "envelope"
				{
					len_char = strlen(msg_recu);
					msg_recu[(len_char - 1)] = '\0';

					for (int j = 0; j < 9; j++)
					{
						if (strstr(msg_recu, element_Envelope[j]) != NULL)
						{
							printf("element_Envelope : %s \n", element_Envelope[j]);
							sprintf(buffer, "(\" %s \") \n", msg_recu);
							strcat(contenu_Envelope, buffer);
							break;
						}
					}
				}
			}
			//fwrite(contenu_Envelope, 1, sizeof(contenu_Envelope), dialogue);
		}

		/*******************************Lect_Mail:822.HEADER***********************/
		if (fecth_att.iRfc_header == 1)
		{
			FILE *monFichier = NULL;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			monFichier = fopen(Chemin, "r");
			if (monFichier != NULL)
			{
				while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On cherche si le fichier contient les élement qui definisse "envelope"
				{

					for (int j = 0; j < 14; j++)
					{
						if (strstr(msg_recu, element_Header[j]) != NULL)
						{
							sprintf(buffer, "%s", msg_recu);
							strcat(contenu_Header, buffer);
							break;
						}
					}
				}
			}

			//fwrite(contenu_Header, 1, sizeof(contenu_Header), dialogue);
		}

		/*******************************Lect_Mail:822.Text*************************/
		if (fecth_att.iRfc_text == 1)
		{
			FILE *monFichier = NULL;
			sprintf(Chemin, "../Messages/Utilisateur/%s/INBOX/%d.txt", user, tab_enum[i]);
			monFichier = fopen(Chemin, "r");
			if (monFichier != NULL)
			{
				while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On cherche si le fichier contient les élement qui definisse "envelope"
				{
					iBuffer = 0;
					// printf("message reçu : %s \n",msg_recu);
					// len_msg=strlen(msg_recu);
					// msg_recu[(len_msg-1)]='\0';

					for (int j = 0; j < 9; j++)
					{
						if (strstr(msg_recu, element_Envelope[j]) != NULL)
						{
							iBuffer = 1;
						}
					}
					if (iBuffer == 0)
					{
						sprintf(buffer, "%s\n", msg_recu);
						strcat(contenu_Text, buffer);
					}
				}

				//fwrite(contenu_Text, 1, sizeof(contenu_Text), dialogue);
			}
		}
		/*****************************Lect_Mail:Renvoi Info au client*************************/
		iBuffer = 0;
		if (fecth_att.iFlags == 1)
		{
			strcat(Reponse_final, flag_recu[i]);
		}
		if (fecth_att.iInternaldate == 1)
		{
			strcat(Reponse_final, internaldate);
		}
		if (fecth_att.iRfc_size == 1)
		{
			strcat(Reponse_final, rfc822_size);
		}

		if (fecth_att.iEnvelope == 1)
		{
			strcat(Reponse_final, contenu_Envelope);
		}

		if (fecth_att.iRfc_header == 1)
		{
			strcat(Reponse_final, contenu_Header);
		}

		if (fecth_att.iRfc_text == 1)
		{
			strcat(Reponse_final, contenu_Text);
		}
		sprintf(buffer, "%d", tab_enum[i]);
		//printf("tabenum %d \n",tab_enum[i]);
		if (strcmp(buffer, "0") == 0)
		{
			printf("le fichier a FETCH n'existe pas : %d \na ", tab_enum[i]);
		}
		else
		{
			sprintf(buffer2, "\n* Fetch %d (%s) \n", tab_enum[i], Reponse_final);
			fwrite(buffer2, 1, sizeof(buffer2), dialogue);
		}

		/*vidage des contenu des chars */
		memset(Reponse_final, 0, sizeof(Reponse_final));
		memset(internaldate, 0, sizeof(internaldate));
		memset(rfc822_size, 0, sizeof(rfc822_size));
		memset(contenu_Envelope, 0, sizeof(contenu_Envelope));
		memset(contenu_Text, 0, sizeof(contenu_Text));
		memset(contenu_Header, 0, sizeof(contenu_Header));
		memset(buffer, 0, sizeof(buffer));
		memset(buffer2, 0, sizeof(buffer2));
		tab_enum[i] = 0;
		// strcpy(Reponse_final,"");
		// strcpy(internaldate,"");
		// strcpy(rfc822_size,"");
		// strcpy(contenu_Envelope,"");
		// strcpy(contenu_Text,"");
		// strcpy(contenu_Header,"");
		// strcpy(buffer,"");
		// strcpy(buffer2,"");
	}
	//memset(tab_enum, 0, sizeof(tab_enum));
}

/*************************************************************ANALYSE ARGUMENTS***************************************************/

char *analyseArguments(int argc, char *argv[])
{
	int option_index = 0;
	int c = 0;
	//char *pend;
	static struct option long_options[] =
		{
			{"spool", required_argument, 0, 's'},
			{0, 0, 0, 0}};
	while ((c = getopt_long(argc, argv, "s:", long_options, &option_index)) != -1)
	{
		if (c == -1)
			break;

		printf("nouveau chemin: %s\n", optarg);
		return optarg;
	}

	printf("chemin par defaut: \"/var/spool/mail\"\n");
	return "/var/spool/mail";
}